#include "dup.h"

//
// This function store the filename and the current path
// into a map(hashtable)
//
void dup::processFile( const char * dirName, const char * fName)
{
	string file, path;
	list< string > pathList;

	char *nameCopy1, *nameCopy2;

	nameCopy1 = (char *) malloc( strlen( dirName ) + 1 );
	strcpy( nameCopy1, dirName );

	nameCopy2 = (char *) malloc( strlen( fName ) + 1 );
	strcpy( nameCopy2, fName );

	file = string( nameCopy1 );
	path = string( nameCopy2 );

	// file = string( fName );
	// path = string( dirName );

	// if the the file has not been put to the set
	// put it into the set
	fileNameSet.insert( file );
	
	pathList = fileNpath[ file ];
	pathList.push_back( path );

	return;
}

void dup::printResult()
{
	typedef map< string, list< string > >::const_iterator	idxOfMap;
	typedef set< string >::iterator idxOfSet;
	typedef list< string >::iterator idxOfList;

	idxOfMap mIdx;
	idxOfSet sIdx;
	idxOfList lIdx;
	string file, path;
	list< string > pathList;

	// for( mIdx = fileNameSet.begin(); mIdx != fileNameSet.end(); ++mIdx)
	// Displaying the duplicated filenames
	for( mIdx = fileNpath.begin(); mIdx != fileNpath.end(); ++mIdx ) {
		pathList = mIdx->second;
		if( mIdx->second.size() > 1 ) {
			cout << "File name " << mIdx->first << " is duplicated in the following directories: " << endl;
			for( lIdx = mIdx->second.begin(); lIdx != mIdx->second.end(); ++lIdx) {
				cout << "    " << *lIdx << endl;
			}
		}
	}
}

//----< test stub >--------------------------------------------
int main(int argc, char *argv[])
{
  dup * visitor = new dup;
  cout << "\n  Demonstrating finding duplicated filenames! \n"
       << "\n ===================================================\n\n";

  char curDir[ 256 ];

  if( !GetCurrentDirectory( 256, curDir ) ) {
    cerr << "Couldn't get the current directory." << endl;
    return( 1 );
  }

  // List all files, starting with the current directory
  visitor->traverse( curDir, "*.*" );
  cout << endl;

  visitor->printResult();
  // visitor->traverse(curDir, "*.*");
  // cout << endl;

  return 0;
}